//---------------------------------------------------------------------------
//  VTreeHolder.h
// (c) RVA (r Doga, or BARDAKC) (c)
//    TVirtualStringTree  IShellFolder
//---------------------------------------------------------------------------
#include <system.hpp>
#include <Graphics.hpp>

#include "VirtualTrees.hpp"
#include "ThemeMgr.hpp"

#define NO_WIN32_LEAN_AND_MEAN
#include <ShlObj.hpp>
//---------------------------------------------------------------------------
#ifndef VTreeHolderH
#define VTreeHolderH
//---------------------------------------------------------------------------
using namespace std;
//---------------------------------------------------------------------------
#ifndef MM_ID
#define MM_ID
//  (MonitorMode)
enum MM
     {
       //mmNone = 0,
       mmDAT  = 1, // 
       mmRXD  = 2, // 
     };  
#endif     

#ifndef NT_ID
#define NT_ID
//  (NodeType)
enum NT
     {
       ntNone              = 0,
       ntLocalDrive        = 1,
       ntNetDrive          = 2,
       ntFavorite          = 3,
       ntDesnaHolder       = 4,
       ntDesnaHolderPlant  = 5,  //  ntDesnaHolder
       ntDesnaHolderUnit   = 6,  //  ntDesnaHolderPlant
       ntDesnaHolderRepair = 7,  //  ntDesnaHolderUnit
       ntDesnaHolderObject = 8,  //  ntDesnaHolderRepair
     };

//  (NodeStatus)
enum NS
     {
       nsOK        = 0,
       nsDisabled  = 1, //   
       nsWrong     = 2, //     ( , ,  ...),   ntDesnaHolder
     }; 
#endif      
//---------------------------------------------------------------------------
class TVTreeHolderOperator;
//---------------------------------------------------------------------------
class TNodeData : public TObject
{
  friend class TVTreeHolderOperator; 

  private:

  protected:  
    NT          FNodeType;
    NS          FNodeStatus;

    bool        FHasChildren;

    int         FNodeClosedImageIndex;
    int         FNodeOpenImageIndex;

    int         FNodeLevel;
    

    AnsiString  FFullPath;
    AnsiString  FNodeText;
    AnsiString  FNodeHint;
    
    TItemIDList          *FPIDL;  
    TItemIDList          *FFullPIDL;
    IShellFolder         *FShellFolder;
    TVTreeHolderOperator *FShellMallocOwner;


  public:
    __property AnsiString FullPath = {read = FFullPath};
  
    void __fastcall Init(int ANodeLevel, 
                         NT ANodeType, 
                         NS FNodeStatus, 
                         bool AHasChildren, 
                         int ANodeNotOpenImageIndex, 
                         int ANodeOpenImageIndex, 
                         AnsiString  AFullPath, 
                         AnsiString ANodeText, 
                         AnsiString  ANodeHint, 
                         TVTreeHolderOperator *AShellMallocOwner, 
                         TItemIDList *APIDL, 
                         TItemIDList *AFullPIDL, 
                         IShellFolder *AShellFolder);

    __fastcall TNodeData(void);
    __fastcall ~TNodeData();
};     
//---------------------------------------------------------------------------
typedef struct {
                 TNodeData *NodeData;
               } VTVNODEDATA;
//---------------------------------------------------------------------------
class TVTreeHolderOperator : public System::TObject
{
  friend class TNodeData; 

  private:

  protected:       
    MM      FMonitorMode;

    int     FImageListConstCount;

    HRESULT FHResult;
    
    LPMALLOC           FpShellMalloc;
    TVirtualStringTree *FVTreeViewHolder;
    TImageList         *FHolderImages;
    //IGlobal            *FGlobal;

    void        __fastcall NodeFreeEvent(TBaseVirtualTree *Sender, PVirtualNode Node);
    void        __fastcall NodeCollapsedEvent(TBaseVirtualTree *Sender, PVirtualNode Node);
    void        __fastcall NodeExpandingEvent(TBaseVirtualTree *Sender, PVirtualNode Node, bool &Allowed);
    void        __fastcall NodeGetImageIndexEvent(TBaseVirtualTree *Sender, PVirtualNode Node, TVTImageKind Kind, 
                             TColumnIndex Column, bool &Ghosted, int &ImageIndex);
    void        __fastcall NodeGetTextEvent(TBaseVirtualTree *Sender, PVirtualNode Node, TColumnIndex Column, 
                             TVSTTextType TextType, WideString &CellText);
    void        __fastcall NodeBeforePaintEvent(TBaseVirtualTree *Sender, const TCanvas *TargetCanvas,
                             PVirtualNode Node, TColumnIndex Column, TVSTTextType TextType);
    
    char*       __fastcall GetDisplayName(TItemIDList *pidl, const TStrRet &Value);
    void*       __fastcall GetShellImage(PItemIDList PIDL, bool Open);
    PItemIDList __fastcall CreatePIDL(int Size);
    PItemIDList __fastcall ConcatPIDLs(PItemIDList IDList1, PItemIDList IDList2);
    int         __fastcall GetPIDLSize(PItemIDList IDList);
    PItemIDList __fastcall NextPIDL(PItemIDList IDList);
    bool        __fastcall GetHasSubItems(_di_IShellFolder ShellFolder, int Flags);
    int         __fastcall AddNewIcon(TIcon *AIcon);
    NT          __fastcall GetNewNodeType(NT ANodeType);
    
  public:
    __property MM MonitorMode = {read = FMonitorMode};
  
    void __fastcall Init(TVirtualStringTree  *AVTreeViewHolder, TImageList *AHolderImages, /*IGlobal *AGlobal,*/ 
                      MM AMonitorMode);
  
    __fastcall TVTreeHolderOperator(void);
    __fastcall ~TVTreeHolderOperator();
};  
//---------------------------------------------------------------------------
#endif
